import { DestFns, SrcFn } from './settings'
import fetch from 'node-fetch'

export function test_src(payload: any) {
  return fetch('http://127.0.0.1:3001/function', {
    method: 'post',
    body: JSON.stringify(payload),
    headers: {
      'Content-Type': 'application/json'
    }
  }).then(r => r.json())
}

export async function test_dest(payload: any) {
  return fetch('http://127.0.0.1:3001/function', {
    method: 'post',
    body: JSON.stringify(payload),
    headers: {
      'Content-Type': 'application/json'
    }
  })
}

export async function call_src(payload: any, onRequest: SrcFn, output: any) {
  output.tracks = []
  output.identifies = []
  output.groups = []
  output.aliases = []
  output.screens = []
  output.pages = [];

  (global as any).Segment = {
    identify(i: SegmentOptions<SegmentSourceIdentify> & SegmentId) {
      output.identifies.push(i)
    },
    track<E extends SegmentEvents>(t: SegmentOptions<SegmentTrackObject<E>> & SegmentId) {
      output.tracks.push(t)
    },
    group(t: SegmentOptions<SegmentGroup> & SegmentId) {
      output.groups.push(t)
    },
    alias(t: SegmentOptions<SegmentAlias> & SegmentId) {
      output.aliases.push(t)
    },
    page(t: SegmentOptions<SegmentPage> & SegmentId) {
      output.pages.push(t)
    },
    screen(t: SegmentOptions<SegmentScreen> & SegmentId) {
      output.screens.push(t)
    }
  };

  await onRequest(payload, {})
}

export async function call_dest(event: any, fns: DestFns) {
  const settings = {}
  switch (event.type) {
    case 'alias': {
      if (fns.onAlias) {
        fns.onAlias(event, settings)
      }
      break
    }
    case 'identify': {
      if (fns.onIdentify) {
        fns.onIdentify(event, settings)
      }
      break
    }
    case 'page': {
      if (fns.onPage) {
        fns.onPage(event, settings)
      }
      break
    }
    case 'screen': {
      if (fns.onScreen) {
        fns.onScreen(event, settings)
      }
      break
    }
    case 'track': {
      if (fns.onTrack) {
        fns.onTrack(event, settings)
      }
      break
    }
    case 'group': {
      if (fns.onGroup) {
        fns.onGroup(event, settings)
      }
      break
    }
  }
}